package com.qmth.distributed.print.business.bean.result;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.qmth.teachcloud.common.enums.FlowStatusEnum;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.util.Objects;

/**
 * @Description: 流程审批列表result
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2021/8/5
 */
@JsonInclude(JsonInclude.Include.NON_NULL)
public class TaskApproveResult implements Serializable {

    @JsonSerialize(using = ToStringSerializer.class)
    @ApiModelProperty(value = "流程id")
    private Long flowId;

    @JsonSerialize(using = ToStringSerializer.class)
    @ApiModelProperty(value = "学校id")
    private Long schoolId;

    @JsonSerialize(using = ToStringSerializer.class)
    @ApiModelProperty(value = "机构id")
    private Long orgId;

    @JsonSerialize(using = ToStringSerializer.class)
    @ApiModelProperty(value = "命题任务id")
    private Long taskId;

    @JsonSerialize(using = ToStringSerializer.class)
    @ApiModelProperty(value = "发起人id")
    private Long teacherId;

    @ApiModelProperty(value = "发起人名称")
    private String teacherName;

    @ApiModelProperty(value = "创建时间")
    private Long createTime;

    @JsonSerialize(using = ToStringSerializer.class)
    @ApiModelProperty(value = "一级审核人id")
    private Long primaryApproveId;

    @ApiModelProperty(value = "一级审核人名称")
    private String primaryApproveName;

    @ApiModelProperty(value = "一级审核人意见")
    private String primaryApproveRemark;

    @JsonSerialize(using = ToStringSerializer.class)
    @ApiModelProperty(value = "二级审核人id")
    private Long secondApproveId;

    @ApiModelProperty(value = "二级审核人名称")
    private String secondApproveName;

    @ApiModelProperty(value = "二级审核人意见")
    private String secondApproveRemark;

    @ApiModelProperty(value = "流程状态")
    private FlowStatusEnum status;

    @ApiModelProperty(value = "流程状态")
    private String statusStr;

    public Long getFlowId() {
        return flowId;
    }

    public void setFlowId(Long flowId) {
        this.flowId = flowId;
    }

    public Long getSchoolId() {
        return schoolId;
    }

    public void setSchoolId(Long schoolId) {
        this.schoolId = schoolId;
    }

    public Long getOrgId() {
        return orgId;
    }

    public void setOrgId(Long orgId) {
        this.orgId = orgId;
    }

    public Long getTaskId() {
        return taskId;
    }

    public void setTaskId(Long taskId) {
        this.taskId = taskId;
    }

    public Long getTeacherId() {
        return teacherId;
    }

    public void setTeacherId(Long teacherId) {
        this.teacherId = teacherId;
    }

    public String getTeacherName() {
        return teacherName;
    }

    public void setTeacherName(String teacherName) {
        this.teacherName = teacherName;
    }

    public Long getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Long createTime) {
        this.createTime = createTime;
    }

    public Long getPrimaryApproveId() {
        return primaryApproveId;
    }

    public void setPrimaryApproveId(Long primaryApproveId) {
        this.primaryApproveId = primaryApproveId;
    }

    public String getPrimaryApproveName() {
        return primaryApproveName;
    }

    public void setPrimaryApproveName(String primaryApproveName) {
        this.primaryApproveName = primaryApproveName;
    }

    public String getPrimaryApproveRemark() {
        return primaryApproveRemark;
    }

    public void setPrimaryApproveRemark(String primaryApproveRemark) {
        this.primaryApproveRemark = primaryApproveRemark;
    }

    public Long getSecondApproveId() {
        return secondApproveId;
    }

    public void setSecondApproveId(Long secondApproveId) {
        this.secondApproveId = secondApproveId;
    }

    public String getSecondApproveName() {
        return secondApproveName;
    }

    public void setSecondApproveName(String secondApproveName) {
        this.secondApproveName = secondApproveName;
    }

    public String getSecondApproveRemark() {
        return secondApproveRemark;
    }

    public void setSecondApproveRemark(String secondApproveRemark) {
        this.secondApproveRemark = secondApproveRemark;
    }

    public FlowStatusEnum getStatus() {
        return status;
    }

    public void setStatus(FlowStatusEnum status) {
        this.status = status;
    }

    public String getStatusStr() {
        if (Objects.nonNull(status)) {
            return status.getTitle();
        } else {
            return statusStr;
        }
    }

    public void setStatusStr(String statusStr) {
        this.statusStr = statusStr;
    }
}
