package com.qmth.distributed.print.business.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.distributed.print.business.bean.dto.TaskPrintClassDto;
import com.qmth.distributed.print.business.bean.params.BasicStudentParams;
import com.qmth.distributed.print.business.bean.result.BasicStudentResult;
import com.qmth.distributed.print.business.entity.BasicStudent;

import java.util.List;

/**
 * <p>
 * 学校id 服务类
 * </p>
 *
 * @author wangliang
 * @since 2021-08-02
 */
public interface BasicStudentService extends IService<BasicStudent> {

    IPage<BasicStudent> listPage(Page<BasicStudent> page, String classId);

    List<TaskPrintClassDto> listByClass(Long schoolId, List<String> stringList);
    /**
     * 学生基础信息分页查询
     * @param queryParams 查询参数（学生学号或姓名）
     * @param pageNumber 分页页码
     * @param pageSize 分页容量
     * @return 分页结果
     */
    IPage<BasicStudentResult> basicStudentPage(String queryParams,int pageNumber,int pageSize);

    /**
     * 新增/编辑 学生基础信息
     * @param basicStudentParams 基础学生信息参数
     * @return 新增或编辑的校区id
     */
    Long saveBasicStudent(BasicStudentParams basicStudentParams);

    /**
     * 批量删除学生基本信息（逻辑）
     * @param idList 要删除的学生主键集合
     * @return 是否删除成功
     */
    Boolean removeBasicStudentBatch(List<Long> idList);
}
